Index: /LMDZ6/trunk/bld.cfg
===================================================================
--- /LMDZ6/trunk/bld.cfg	(revision 3900)
+++ /LMDZ6/trunk/bld.cfg	(revision 3901)
@@ -111,2 +111,3 @@
 bld::outfile_ext::mod .mod
 bld::tool::SHELL   /bin/bash
+bld::tool::SHELL   /bin/ksh
Index: /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 3900)
+++ /LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 3901)
@@ -330,5 +330,5 @@
     ! Martin et Etienne
     !Config Key  = landice_opt
-    !Config Desc = which landice snow model (BULK, SISVAT or INLANDSIS)
+    !Config Desc = which landice snow model (BULK, or INLANDSIS)
     !Config Def  = 0
     landice_opt_omp = 0
Index: /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3900)
+++ /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3901)
@@ -519,5 +519,5 @@
 
 ! Martin
-! sisvat
+! inlandsis
     REAL, DIMENSION(klon),       INTENT(OUT)        :: qsnow      ! snow water content
     REAL, DIMENSION(klon),       INTENT(OUT)        :: snowhgt    ! snow height
Index: /LMDZ6/trunk/libf/phylmd/surf_landice_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/surf_landice_mod.F90	(revision 3900)
+++ /LMDZ6/trunk/libf/phylmd/surf_landice_mod.F90	(revision 3901)
@@ -33,7 +33,4 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
 
-#ifdef CPP_SISVAT
-    USE surf_sisvat_mod,  ONLY : surf_sisvat
-#endif
 
 #ifdef CPP_INLANDSIS
@@ -179,81 +176,13 @@
 !****************************************************************************************
 !  landice_opt = 0 : soil_model, calcul_flux, fonte_neige, ...  
-!  landice_opt = 1  : prepare and call SISVAT snow model
-!  landice_opt = 2  : prepare and call INLANDSIS snow model
+!  landice_opt = 1  : prepare and call INterace Lmdz SISvat (INLANDSIS)
 !****************************************************************************************
 
 
     IF (landice_opt .EQ. 1) THEN
-    
-!****************************************************************************************
-! CALL to SISVAT interface
-!****************************************************************************************
-
-#ifdef CPP_SISVAT
-       ! Prepare for calling SISVAT
-       
-       ! Calculate incoming flux for SW and LW interval: swdown, lwdown
-       swdown(:)        = 0.0
-       lwdown(:)        = 0.0
-       DO i = 1, knon
-          swdown(i)        = swnet(i)/(1-albedo(i))
-          lwdown(i)        = lwdownm(i)
-       END DO
-       
-       ! Set constants and compute some input for SISVAT
-       snow_adv(:)      = 0.                          ! no snow blown in for now
-       snow_cont_air(:) = 0.       
-       alb_soil(:)      = albedo(:)
-       pref             = 100000.                     ! = 1000 hPa
-       DO i = 1, knon
-          wind_velo(i)     = u1(i)**2 + v1(i)**2
-          wind_velo(i)     = wind_velo(i)**0.5
-          pexner(i)        = (p1lay(i)/pref)**(RD/RCPD)
-          dens_air(i)      = p1lay(i)/RD/temp_air(i)  ! dry air density
-          zsl_height(i)     = pphi1(i)/RG              
-       END DO
-
-
-       ! config: compute everything with SV but temperatures afterwards with soil/calculfluxs
-       DO i = 1, knon
-          tsoil0(i,:)=tsoil(i,:)
-       END DO
-           ! Martin
-           PRINT*, 'on appelle surf_sisvat'
-           ! Martin
-       CALL surf_sisvat(knon, rlon, rlat, knindex, itime, dtime, debut, lafin, &
-            rmu0, swdown, lwdown, pexner, ps, p1lay, &
-            precip_rain, precip_snow, precip_snow_adv, snow_adv, &
-            zsl_height, wind_velo, temp_air, dens_air, spechum, tsurf, &
-            rugoro, snow_cont_air, alb_soil, slope, cloudf, &
-            radsol, qsol, tsoil0, snow, snowhgt, qsnow, to_ice,sissnow, agesno, &
-            AcoefH, AcoefQ, BcoefH, BcoefQ, cdragh, &
-            run_off_lic, evap, fluxsens, fluxlat, dflux_s, dflux_l, &        
-            tsurf_new, alb1, alb2, alb3, emis_new, z0m, qsurf)
-       z0h(1:knon)=z0m(1:knon) ! en attendant mieux
-       
-       ! Suppose zero surface speed
-       u0(:)            = 0.0
-       v0(:)            = 0.0
-       ! The calculation of heat/water fluxes, otherwise done by "CALL calcul_fluxs" is 
-       ! integrated in SISVAT, using the same method. It can be found in "sisvat.f", in the
-       ! subroutine "SISVAT_TS2". 
-       ! u0, v0=0., dif_grnd=0. and beta=1 are assumed there! 
-       
-       CALL calcul_flux_wind(knon, dtime, &
-            u0, v0, u1, v1, gustiness, cdragm, &
-            AcoefU, AcoefV, BcoefU, BcoefV, &
-            p1lay, temp_air, &
-            flux_u1, flux_v1)
-#else
-       abort_message='Pb de coherence: landice_opt = 1 mais CPP_SISVAT = .false.'
-       CALL abort_physic(modname,abort_message,1)
-#endif
-
-!****************************************************************************************
+
+!****************************************************************************************    
 ! CALL to INLANDSIS interface
 !****************************************************************************************
-
-    ELSE IF (landice_opt .EQ. 2) THEN
 #ifdef CPP_INLANDSIS
 
@@ -330,5 +259,5 @@
 
 #else
-       abort_message='Pb de coherence: landice_opt = 2 mais CPP_INLANDSIS = .false.'
+       abort_message='Pb de coherence: landice_opt = 1  mais CPP_INLANDSIS = .false.'
        CALL abort_physic(modname,abort_message,1)
 #endif
@@ -480,5 +409,5 @@
        alb_dir(1:knon,6)=alb2(1:knon)
 
-       IF ((landice_opt .EQ.2) .AND. (iflag_albcalc .EQ. 2)) THEN
+       IF ((landice_opt .EQ. 1) .AND. (iflag_albcalc .EQ. 2)) THEN
        alb_dir(1:knon,1)=alb6(1:knon,1)
        alb_dir(1:knon,2)=alb6(1:knon,2)
Index: /LMDZ6/trunk/libf/phylmd/surface_data.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/surface_data.F90	(revision 3900)
+++ /LMDZ6/trunk/libf/phylmd/surface_data.F90	(revision 3901)
@@ -30,6 +30,6 @@
   !===============
  
-   ! 1 for coupling with SISVAT, 2 for coupling with INLANDSIS and number of subtimesteps for INLANDSIS
-   INTEGER, SAVE          :: landice_opt      ! 1 for coupling with SISVAT, 2 for coupling with INLANDSIS
+   ! 1 for coupling with INLANDSIS
+   INTEGER, SAVE          :: landice_opt   ! 1 for coupling with INLANDSIS
   !$OMP THREADPRIVATE(landice_opt)
 
Index: /LMDZ6/trunk/makegcm
===================================================================
--- /LMDZ6/trunk/makegcm	(revision 3900)
+++ /LMDZ6/trunk/makegcm	(revision 3901)
@@ -41,5 +41,4 @@
 set cosp2=false
 set cospv2=false
-set sisvat=false
 set inlandsis=false
 
@@ -517,6 +516,4 @@
      case -cospv2
         set cospv2="$2"; shift ; shift ; goto top
-     case -sisvat
-        set sisvat="$2" ; shift ; shift ; goto top
      case -inlandsis
         set inlandsis="$2" ; shift ; shift ; goto top
@@ -621,8 +618,4 @@
 
 
-if ( "$sisvat" == 'true' ) then
-    set cppflags="$cppflags -DCPP_SISVAT"
-endif
-
 if ( "$inlandsis" == 'true' ) then
     set cppflags="$cppflags -DCPP_INLANDSIS"
Index: /LMDZ6/trunk/makelmdz
===================================================================
--- /LMDZ6/trunk/makelmdz	(revision 3900)
+++ /LMDZ6/trunk/makelmdz	(revision 3901)
@@ -27,5 +27,4 @@
 cosp2=false
 cospv2=false
-sisvat=false
 inlandsis=false
 rrtm=false
@@ -122,5 +121,4 @@
 [-cosp2 true/false]    : compile with/without cosp2 package (default: false)
 [-cospv2 true/false]    : compile with/without cospv2 package (default: false)
-[-sisvat true/false]  : compile with/without sisvat package (default: false)
 [-inlandsis true/false]  : compile with/without inlandsis package (default: false)
 [-rrtm true/false]    : compile with/without rrtm package (default: false)
@@ -192,7 +190,4 @@
           cospv2="$2" ; shift ; shift ;;
       
-      "-sisvat")
-          sisvat="$2" ; shift ; shift ;;
-
       "-inlandsis")
           inlandsis="$2" ; shift ; shift ;;  
@@ -515,11 +510,4 @@
    src_dirs="$src_dirs phy${physique}/cospv2"
    INCLUDE="$INCLUDE"' -I$(LIBF)/'phy${physique}'/cospv2'
-fi
-
-
-if [[ "$sisvat" == "true" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_SISVAT"
-   src_dirs="$src_dirs phy${physique}/sisvat"
 fi
 
Index: /LMDZ6/trunk/makelmdz_fcm
===================================================================
--- /LMDZ6/trunk/makelmdz_fcm	(revision 3900)
+++ /LMDZ6/trunk/makelmdz_fcm	(revision 3901)
@@ -23,5 +23,4 @@
 couple=false
 veget=false
-sisvat=false
 inlandsis=false
 rrtm=false
@@ -55,7 +54,7 @@
 PHY_COMMON_PATH=$LMDGCM/.void_dir
 RRTM_PATH=$LMDGCM/.void_dir
+INLANDSIS_PATH=$LMDGCM/.void_dir
 DUST_PATH=$LMDGCM/.void_dir
 STRATAER_PATH=$LMDGCM/.void_dir
-SISVAT_PATH=$LMDGCM/.void_dir
 COSP_PATH=$LMDGCM/.void_dir
 fcm_path=$LMDGCM/tools/fcm/bin
@@ -99,5 +98,4 @@
 [-cosp2 true/false]    : compile with/without cosp2 package (default: false)
 [-cospv2 true/false]    : compile with/without cospv2 package (default: false)
-[-sisvat true/false]  : compile with/without sisvat package (default: false)
 [-inlandsis true/false]  : compile with/without inlandsis package (default: false)
 [-rrtm true/false]    : compile with/without rrtm package (default: false)
@@ -150,7 +148,4 @@
       "-v")
 	  veget="$2" ; shift ; shift ;;
-
-      "-sisvat")
-	  sisvat="$2" ; shift ; shift ;;
 
       "-inlandsis")
@@ -414,10 +409,4 @@
 fi
 
-if [[ "$sisvat" == "true" ]]
-then
-   CPP_KEY="$CPP_KEY CPP_SISVAT"
-   SISVAT_PATH="$LIBFGCM/%PHYS/sisvat"
-fi
-
 if [[ "$inlandsis" == "true" ]]
 then
@@ -697,5 +686,4 @@
 echo "%DUST          $DUST_PATH"     >> $config_fcm
 echo "%STRATAER      $STRATAER_PATH" >> $config_fcm
-echo "%SISVAT        $SISVAT_PATH"   >> $config_fcm
 echo "%INLANDSIS     $INLANDSIS_PATH" >> $config_fcm
 echo "%COSP          $COSP_PATH"     >> $config_fcm