Index: BOL/Multi_atlas/atlas/atlas_none.py
===================================================================
--- BOL/Multi_atlas/atlas/atlas_none.py	(revision 3885)
+++ BOL/Multi_atlas/atlas/atlas_none.py	(revision 3915)
@@ -36,4 +36,5 @@
 parser.add_option("-f", "--force", help="force le recalcul de champs existants", 
                   action="store_true",default=None)
+parser.add_option("--dirpng",help="Path of the simulation directory", action="store",default=None)
 parser.add_option("-o", "--pdf", help="nom du pdf de sortie (default: atlas_<SIMU>_<SAISON>.pdf)", action="store")
 (opts, args) = parser.parse_args()
@@ -131,4 +132,15 @@
 		  mpCenterLonF=0,
 		  **pparams)
+###11052021 begin
+#    # Single figures
+    page=cpage([[simu_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+    pdf_page=cpage([[simu_fig]],orientation='landscape',
+        page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+#pdfargs.append(cfile(pdf_page,target='/home/fabric/users/musat/myatlas/simu_fig.pdf'))
+    #pdffile="atlas_"+opts.simulation+"_"+opts.season+".pdf"
+    #pdfargs.append(cfile(pdf_page,target=opts.simumapp))
+    pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.simulation+"/MAP/"+variable+".pdf"))
+#
+###11052021 end
     simu_avg=cvalue(space_average(simu))
     #
@@ -141,4 +153,11 @@
 		 mpCenterLonF=0,
                  **pparams)
+###11052021 begin
+    #    # Single figures ref_fig
+    page=cpage([[ref_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+    pdf_page=cpage([[ref_fig]],orientation='landscape',
+        page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+    pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.reference+"/MAP/"+variable+".pdf"))
+###11052021 end
     ref_avg=cvalue(space_average(reff))
     #
@@ -174,4 +193,9 @@
 		  gsnStringFontHeightF=stringFontHeight,
                   aux_options='cnLineThicknessF=2|cnLineLabelsOn=True', **p)
+    #    # Single figures diff_fig
+        page=cpage([[diff_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+        pdf_page=cpage([[diff_fig]],orientation='landscape',
+                page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+        pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.simulation+"/DMAP_"+opts.reference+"/"+variable+".pdf"))
     else:
         p.update({'contours':1})
@@ -229,4 +253,21 @@
 				 'gsnRightString='+opts.season+'|'+\
 				 'gsnStringFontHeightF='+str(stringFontHeight))
+    #    # Single figures
+	page=cpage([[simu_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+	pdf_page=cpage([[simu_fig]],orientation='landscape', 
+		page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+        pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.simulation+"/MAP/"+variable+".pdf"))
+    #    # Single figures ref_fig
+	page=cpage([[ref_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+	pdf_page=cpage([[ref_fig]],orientation='landscape', 
+		page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+        pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.reference+"/MAP/"+variable+".pdf"))
+    #    # Single figures diff_fig
+	page=cpage([[diff_fig]],orientation='landscape', page_trim=True, fig_trim=True)
+	pdf_page=cpage([[diff_fig]],orientation='landscape', 
+		page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
+        pdfargs.append(cfile(pdf_page,target=opts.dirpng+"/"+opts.season+"/"+opts.simulation+"/DMAP_"+opts.reference+"/"+variable+".pdf"))
+# Creation du Pdf multi-pages
+	comm=subprocess.Popen(pdfargs, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
     #    # Composite figure
     if is3d(variable):
@@ -238,5 +279,4 @@
     	pdf_page=cpage([[simu_fig,ref_fig],[diff_fig,zmean_fig]],orientation='landscape', 
                    page_trim=True, fig_trim=True, format='pdf', title=variable+" "+opts.simulation)
-    pdfargs.append(cfile(pdf_page))
     #
     thumbnail_size = 200